//+------------------------------------------------------------------+
//|                                                          FVE.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//|                                      this version made by mladen |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern int            Length1    = 22;
extern ENUM_MA_METHOD MA1_Method = MODE_SMA;
extern int            Length2    =22;
extern ENUM_MA_METHOD MA2_Method = MODE_SMA;

double FVE[],Signal[],Intra[],Inter[],VE[],Vol[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   IndicatorDigits(Digits);
      SetIndexBuffer(0,FVE);
      SetIndexBuffer(1,Signal);
      SetIndexBuffer(2,Intra);
      SetIndexBuffer(3,Inter);
      SetIndexBuffer(4,VE);
      SetIndexBuffer(5,Vol);
   IndicatorShortName("Finite Volume Elements");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int pos,limit = MathMin(Bars-counted_bars,Bars-2);


   for(pos=limit; pos>=0; pos--)
   {
      Intra[pos] = MathLog(High[pos])-MathLog(Low[pos]);
      Inter[pos] = MathLog((High[pos]+Low[pos]+Close[pos])/3.0)-MathLog((High[pos+1]+Low[pos+1]+Close[pos+1])/3.0);
      Vol[pos]   = Volume[pos];
   } 
   for(pos=limit; pos>=0; pos--)
   {
      double Vintra = iStdDevOnArray(Intra, 0, Length1, 0, MODE_SMA, pos);
      double Vinter = iStdDevOnArray(Inter, 0, Length1, 0, MODE_SMA, pos);
      double Cutoff = 0.1*(Vintra+Vinter)*Close[pos];
      double MF     = Close[pos]-(High[pos]+Low[pos])/2.0+High[pos]+Low[pos]+Close[pos]-High[pos+1]-Low[pos+1]-Close[pos+1];
         VE[pos] = 0;
         if (MF >  Cutoff) VE[pos] =  Volume[pos];
         if (MF < -Cutoff) VE[pos] = -Volume[pos];
   }
   for(pos=limit; pos>=0; pos--)
   {
      double MA_VE = iMAOnArray(VE , 0, Length1, 0, MODE_SMA  , pos);
      double MA1   = iMAOnArray(Vol, 0, Length1, 0, MA1_Method, pos);
         FVE[pos]=0; 
         if (MA1!=0) FVE[pos]=100.*MA_VE/(MA1*Point);
   }  
   for(pos=limit; pos>=0; pos--) Signal[pos]=iMAOnArray(FVE, 0, Length2, 0, MA2_Method, pos);
   return(0);
}